SystemOrganization addCategory: #'Seaside-Welcome'!

WAFileLibrary subclass: #WAWelcomeFiles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeFiles commentStamp: '<historical>' prior: 0!
A WAFileLibrary derived class for the WAWelcome* classes
!

!WAWelcomeFiles methodsFor: 'accessing' stamp: 'NickAger 5/23/2010 11:35'!
selectorsToInclude
	^ #( syntaxHighlightingCss welcomeCss )! !

!WAWelcomeFiles methodsFor: 'accessing' stamp: 'NickAger 5/23/2010 13:12'!
syntaxHighlightingCss	^ '
span.patternUnary  {
color:#000000;
font-weight:bold;
}

span.patternKeyword  {
color:#000000;
font-weight:bold;
}

span.patternArg {
color:#000088;
}

span.super  {
color:#008888;
}

span.instanceVar  {
color:#000088;
}

span.number  {
color:#880088;
}

span.receiver  {
color:#000088;
}

span.keyword  {
color:#000000;
}

span.string  {
color:#880088;
}

span.blockArg  {
color:#000088;
}

span.class  {
color:#000088;
}

span.self  {
color:#008888;
}

span.symbol  {
color:#880088;
}
'! !

!WAWelcomeFiles methodsFor: 'accessing' stamp: 'NickAger 5/23/2010 13:37'!
welcomeCss	^ '
body{
border:0 none;
margin:0;
padding:0;
}	
	
.content {
	margin: 10px;
}

.header {
background: #DCEBED;
height: 50px;
}

.headerImage {
float:left;
}

.headerText {
padding: 10px;
}

.introText {
margin-top: 20px;
}

a img {
border: none;
}

.introTable {
	border-spacing:0 5px;
	padding: 0;
	border-collapse: separate;
}


.introTable td {
vertical-align: top;
width:320px;
}


.experiencedUser {
-moz-border-radius: 10px;
-webkit-border-radius: 10px;
background:#F0F0E7;
padding: 10px;
}

.newToSeaside {
background:#F0F0E7;
-moz-border-radius: 10px;
-webkit-border-radius: 10px;
padding: 10px;
}

.example {
	width: 630px;
	padding: 10px;
	background: #F9F9F9;
	border: 1px solid #93BDD5;
	-moz-border-radius: 10px;
	-webkit-border-radius: 10px;
}

.seasideExample {
	background-color: #FBFFFA;
	border: 1px solid #93BDD5;
	margin: 1em;
	padding: 1em;
}

pre.codeSample {
	margin: 2em;
}

'! !

WAComponent subclass: #WAWelcome
	instanceVariableNames: 'example'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcome commentStamp: '<historical>' prior: 0!
An short introduction to Seaside!

!WAWelcome class methodsFor: 'accessing' stamp: 'NickAger 5/23/2010 13:49'!
description
	^ 'An short introduction to Seaside'! !

!WAWelcome class methodsFor: 'class initialization' stamp: 'NickAger 5/23/2010 13:50'!
initialize
	WAAdmin register: self asApplicationAt: 'welcome'! !

!WAWelcome methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 08:37'!
children
	example ifNil: [
		^ #()
		] ifNotNil: [
		^ Array with: example
		]
! !

!WAWelcome methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 09:18'!
renderContentOn: html
	self renderHeaderBarOn: html.
	html div
		class: #content;
		with: [
			self renderIntroTextOn: html.
	
			html table
				class: #introTable;
				with: [ 
					html tableRow:[ 
						html tableData with: [self renderNewToSeasideOn: html].
						html tableData with: [self renderExperiencedUserOn: html]
					]
				].
		self renderExampleOn: html.
		]

! !

!WAWelcome methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 09:26'!
renderExampleOn: html
	example notNil ifTrue: [
		html div
			class: #example;
			with: [
				html render: example
				]
		]
! !

!WAWelcome methodsFor: 'rendering' stamp: 'NickAger 5/22/2010 22:12'!
renderExperiencedUserOn: html
	html div
		class: #experiencedUser;
		with: [
			html heading level2 with: 'Experienced Seaside Developers'.
			html unorderedList: [
				html listItem with: [
					html anchor url: '/browse'; with: 'Browse'.
					html text: ' the applications installed in your image.'
					].
				
				html listItem with: [
					html anchor url: '/javascript/jquery'; with: 'JQuery'.
					html text: ', the new JQuery Seaside integration.'
					].

				html listItem with: [
					html anchor url: '/javascript/jquery-ui'; with: 'JQuery UI'.
					html text: ',	 the new JQuery UI Seaside integration.'
					]
				]
			].
		
! !

!WAWelcome methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 11:12'!
renderHeaderBarOn: html
	html div
		class: #header;
		with: [
			html div
				class: #headerImage;
				with: [
					html anchor
						url: 'http://www.seaside.st';
						with: [
							html image 
								url: JQAllFunctionalTestsLibrary / #seastarPng;
								height: 50; 
								width: 50
						].
				].
			html div
				class: #headerText;
				with: [
					html anchor
						url:  'http://www.seaside.st';
						with: [html heading level2; with: 'Seaside 3.0']
				]
			]! !

!WAWelcome methodsFor: 'rendering' stamp: 'NickAger 5/22/2010 23:31'!
renderIntroTextOn: html
	html div
		class: #introText;
		with: [
			html heading level1; with: 'Welcome'.
			html paragraph: 'Congratulations you have a working Seaside image.'
		]! !

!WAWelcome methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 13:53'!
renderNewToSeasideOn: html
	html div
		class: #newToSeaside; 
		with: [
			html heading level2 with: 'New to Seaside'.
			html paragraph: [
				html text: 'The  '.
				html anchor url: 'http://book.seaside.st'; with: 'Seaside book'.
				html text: ' will teach you all you need to know about Seaside and how to build killer web applications.'
				].

			html  heading level4; with: 'Examples'.
			html unorderedList: [
				html listItem with: [
					html anchor
						callback: [example := WAWelcomeCounterExample new];
						with: 'Counter'.
					html text: ', a simple Seaside component.'.
				].
			
				html listItem with: [
					html anchor
						callback: [example := WAWelcomeMultiCounterExample new];
						with: 'Multi-Counter'.
					html text: ', showing how Seaside components can be re-used.'.
				].
			
				html listItem with: [
					html anchor
						callback: [example := WAWelcomeTaskExample new];
						with: 'Task'.
					html text: ', illustrating Seaside''s innovative approach to application control flow.'.
				].
			]
		].

! !

!WAWelcome methodsFor: 'updating' stamp: 'NickAger 5/23/2010 11:36'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.

	anHtmlRoot link beShortcutIcon; url: WAToolFiles / #faviconIco.
	anHtmlRoot stylesheet url: WAToolFiles / #handlerCss.
	WAWelcomeFiles default updateRoot: anHtmlRoot.
! !

WAComponent subclass: #WAWelcomeCounterExample
	instanceVariableNames: 'counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeCounterExample commentStamp: '<historical>' prior: 0!
Describes and demonstrates the code in WACounter!

!WAWelcomeCounterExample methodsFor: 'hooks' stamp: 'NickAger 5/23/2010 08:25'!
children
	^ Array with: counter! !

!WAWelcomeCounterExample methodsFor: 'initialization' stamp: 'NickAger 5/23/2010 08:14'!
initialize
	super initialize.
	
	counter := WACounter new

! !

!WAWelcomeCounterExample methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 13:43'!
renderContentOn: html
	html heading level1 with: 'Counter'.
	html paragraph: [
		html text: 'The counter is an example of a simple Seaside component. It increments and decrements a number by clicking on a link. Test the example below by clicking on the "++" and "--" links:'.
	].

	html div class: #seasideExample; with: [ html render: counter].

	html paragraph: [		
		html text: 'This application is coded in two short methods. It is implemented in class ';	code: 'WACounter';  text: ', a subclass of '; code: 'WAComponent'
	].

	html paragraph: [		
		html text: 'The first method initializes the counter to 0:'
	].

	self renderInitializeCodeOn: html.
	
	html paragraph: 'The second method is used to generate the output. It also assigns the actions to the anchors (links) that update the current value.'.
	
	self renderRenderContentOnCodeOn: html.
	
! !

!WAWelcomeCounterExample methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 12:02'!
renderInitializeCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'initialize'. html break.
		html span class: #super; with:'    super'. html text:' initialize.'. html break.
		html span class: #instanceVar; with:'    count'. html text: ' := '. html span class: #number; with: '0'		
		].
! !

!WAWelcomeCounterExample methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 12:22'!
renderRenderContentOnCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternKeyword; with: 'renderContentOn: '. html span class: #patternArg; with: 'html'. html break.
    		html span class: #receiver; with: '    html'. html text: ' heading: '. html span class: #instanceVar; with: 'count.'. html break.
		html span class: #receiver; with: '    html'. html text: ' anchor'. html break.
		html text: '        callback: [ '. html span class: #instanceVar; with: 'count '. html text: ':= '. html span class: #instanceVar; with: 'count'. html text: ' + '. html span class: #number; with: '1'. html text: ' ];'. html break.
		html text: '        with: '. html span class: #string; with: '''++'''. html text: '.'. html break.
		html span class: #receiver; with: '    html'. html text: ' space.'. html break.
		html span class: #receiver; with: '    html'. html text: ' anchor'. html break.
		html text: '        callback: [ '. html span class: #instanceVar; with: 'count '. html text: ':= '. html span class: #instanceVar; with: 'count'. html text: ' - '. html span class: #number; with: '1'. html text: ' ];'. html break.
		html text: '        with: '. html span class: #string; with: '''--'''. html text: '.'.
		]! !

WAComponent subclass: #WAWelcomeMultiCounterExample
	instanceVariableNames: 'multicounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeMultiCounterExample commentStamp: '<historical>' prior: 0!
Describes and demonstrates the code in WAMultiCounter!

!WAWelcomeMultiCounterExample methodsFor: 'hooks' stamp: 'NickAger 5/23/2010 08:26'!
children
	^ Array with: multicounter! !

!WAWelcomeMultiCounterExample methodsFor: 'initialization' stamp: 'NickAger 5/23/2010 08:17'!
initialize
	super initialize.
	
	multicounter := WAMultiCounter new.
! !

!WAWelcomeMultiCounterExample methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 12:37'!
renderChildrenCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'children'. html break.
		html text: '    ^ '. html span class: #instanceVar; with: 'counters'
		]
! !

!WAWelcomeMultiCounterExample methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 12:59'!
renderContentOn: html
	html heading level1 with: 'Multi-Counter'.
	
	html paragraph: [
		html text: 'Multicounter is a simple extension to the '.
		html anchor callback: [self show: WAWelcomeCounterExample new]; with: 'Counter'.
		html text: ' application. It displays several instances of the same '.
		html anchor callback: [self show: WAWelcomeCounterExample new]; with: 'counter'.
		html text: ' component:'
		].
	
	html div class: #seasideExample; with: [ html render: multicounter].
	
	html paragraph: [
		html text: 'This component can be written with a few lines of code. It is implemented in the class '; code: 'WAMultiCounter'; text: ', a subclass of '; code: 'WAComponent. '
	].

	html paragraph: 'The first method is used to initialize the component, in this case we instantiate 5 counters:'.
	 
	self renderInitializeCodeOn: html.
	
	html paragraph: 'We also need to tell Seaside what child components we intend to display, in our case this is just the collection of counter instances:'.
	
	self renderChildrenCodeOn: html.
	
	html paragraph: 'Finally we display each of the components separated by a horizontale rule:'.
	
	self renderRenderContentsOnCodeOn: html
	
! !

!WAWelcomeMultiCounterExample methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 12:32'!
renderInitializeCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'initialize'. html break.
		html span class: #super; with:'    super'. html text:' initialize.'. html break.
    		html span class: #instanceVar; with:'    counters'. html text: ' := ('. html span class: #number; with: '1'. html text:' to: '. html span class: #number; with: '5'. html text: ')'. html break.
		html text: '         collect: [ '. html span class: #blockArg; with: ':each'. html text: ' | '. html span class: #class; with: 'WACounter'. html text:' new ]'
		]! !

!WAWelcomeMultiCounterExample methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 12:57'!
renderRenderContentsOnCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternKeyword; with: 'renderContentOn: '. html span class: #patternArg; with: 'html'. html break.
    		html span class: #instanceVar; with: '    counters'. html break.
		html text: '        do: [ '. html span class: #blockArg; with: ':each'. html text: ' | '. html span class: #receiver; with: 'html'.  html text: ' render: '. html span class: #patternArg; with:'each'. html text: ' ]'. html break.
		html text: '         separatedBy: [ '.  html span class: #receiver; with: 'html'. html text: ' horizontalRule ]'
		]
! !

WAComponent subclass: #WAWelcomeTaskExample
	instanceVariableNames: 'counter taskExample'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeTaskExample commentStamp: '<historical>' prior: 0!
Describes and demonstrates the code in WAFlowConvenienceFunctionalTest
!

!WAWelcomeTaskExample methodsFor: 'hooks' stamp: 'NickAger 5/23/2010 09:48'!
children
	^ Array with: taskExample! !

!WAWelcomeTaskExample methodsFor: 'initialization' stamp: 'NickAger 5/23/2010 09:47'!
initialize
	super initialize.
	
	taskExample := WAFlowConvenienceFunctionalTest new! !

!WAWelcomeTaskExample methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 13:17'!
renderChooseCheeseCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'chooseCheese'. html break.
		html span class: #instanceVar; with: '    cheese'. html text: ' := '. html span class: #self; with: 'self'. html break.
		html text: '        chooseFrom: '. html span class: #symbol; with: '#'. html text: '( '. html span class: #string; with: '''Greyerzer'' ''Tilsiter'' ''Sbrinz'''. html text: ' )'. html break.
		html text:'        caption: '. html span class: #string; with: '''What''''s your favorite Cheese?'''. html text: '.'. html break.
		html span class: #instanceVar; with: '    cheese'. html text: ' isNil ifTrue: [ '. html span class: #self; with: 'self'. html text:' chooseCheese ]'
		]
! !

!WAWelcomeTaskExample methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 13:25'!
renderConfirmCheeseCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'confirmCheese'. html break.
		html text: '    ^ '. html span class: #self; with: 'self'. html text: ' confirm: '. html span class: #string; with: '''Is '''. html text:', '. html span class: #instanceVar; with: 'cheese'. html text: ','. html span class: #string; with: ''' your favorite Cheese?'''. html break
		]
! !

!WAWelcomeTaskExample methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 13:47'!
renderContentOn: html
	html heading level1 with: 'Task'.
	html paragraph: [
		html text: 'Complex, multi-page workflows can be expressed in Seaside with a single method. Unlike many web frameworks  which require a separate handler for each page or request, Seaside models an entire user session as a continuous piece of code, with natural, linear control flow.'.
	].

	html div class: #seasideExample; with: [ html render: taskExample].
		
	html paragraph: [		
		html text: 'This example subclasses '; code: 'WATask'; text: ' and implements the hook method '; code: '#go'.
		html text: '. We store the users choice in an instance variable named '; code: 'cheese.'.
	].

	self renderGoCodeOn: html.
	
	html paragraph with: [
		html text: 'To let the user choose from a famous Swiss cheese we use the convenience method '; code: '#chooseFrom:caption:'; text: ' which returns the chosen element from a collection or nil if the user cancelled the dialog. In this case we simply ask again.'
		].
	
	self renderChooseCheeseCodeOn: html.
	
	html paragraph: [
		html text: 'Then we let the user confirm his choice. '; code: '#confirm:'; text: ' answers a '; code: 'boolean'; text: ', '; code: 'true'; text:' or '; code: 'false'; text:':'.
		].
	
	self renderConfirmCheeseCodeOn: html.
	
	html paragraph: [
		html text: 'Finally we display the user''s choice using '; code: '#inform:.'.
		].
	
	self renderInformCheeseCodeOn: html.
	
	html paragraph: 'As simple as that. And yes, the back button still works.'
		
! !

!WAWelcomeTaskExample methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 13:07'!
renderGoCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'go'. html break.
		html text: '    [ '. html span class: #self; with: 'self'. html text: ' chooseCheese.'. html break.
		html text: '      '. html span class: #self; with: 'self'. html text: ' confirmCheese'. html text: ' ] whileFalse.'. html break.
		html text: '    '. html span class: #self; with: 'self'. html text: ' informCheese.'
	]! !

!WAWelcomeTaskExample methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 13:29'!
renderInformCheeseCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'informCheese'. html break.
		html span class: #self; with: '    self'. html text: ' inform: '. html span class: #string; with: '''Your favorite is '''. html text:', '. html span class: #instanceVar; with: 'cheese'. html text: ','. html span class: #string; with: '''.'''. html break
		]! !
WAWelcome initialize!
